#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2200one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2200one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one22004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                                     
# -------------------------------------------------------------------------------------------------
# 2200
# -------------------------------------------------------------------------------------------------                                          
shot2one22004xi = {
                  1:'0x0y2199z',
                  2:'0x1456y1648z',
                  3:'0x66y2199z',
                  4:'1012x1345y1415z',
                  5:'1012x1564y1169z',
                  6:'1019x1055y1639z',
                  7:'1033x1666y997z',
                  8:'105x112y2194z',
                  9:'1061x989y1653z',
                  10:'1072x1279y1432z',
                  11:'1085x1499y1188z',
                  12:'1098x921y1668z',
                  13:'10x263y2184z',
                  14:'1113x1601y1017z',
                  15:'1128x1211y1448z',
                  16:'1132x853y1682z',
                  17:'113x134y2192z',
                  18:'1155x1431y1206z',
                  19:'1161x783y1696z',
                  20:'1179x1140y1465z',
                  21:'1189x1532y1036z',
                  22:'119x157y2191z',
                  23:'1220x1359y1225z',
                  24:'1226x1067y1481z',
                  25:'123x181y2189z',
                  26:'123x232y2184z',
                  27:'124x206y2186z',
                  28:'1261x1460y1056z',
                  29:'1269x992y1497z',
                  30:'126x1824y1222z',
                  31:'126x270y2280z',
                  32:'1281x1285y1243z',
                  33:'12x17y2199z',
                  34:'1307x916y1513z',
                  35:'1328x1384y1075z',
                  36:'1337x1208y1261z',
                  37:'1389x1128y1279z',
                  38:'1391x1305y1094z',
                  39:'1435x1046y1297z',
                  40:'1449x1224y1113z',
                  41:'145x1661y1435z',
                  42:'148x1415y1677z',
                  43:'1502x1139y1132z',
                  44:'171x2035y817z',
                  45:'201x1950y997z',
                  46:'21x240y2186z',
                  47:'220x1389y1691z',
                  48:'220x1803y1240z',
                  49:'230x1636y1451z',
                  50:'23x37y2199z',
                  51:'276x2015y838z',
                  52:'288x1359y1705z',
                  53:'2x22y2199z',
                  54:'2x44y2199z',
                  55:'302x1927y1017z',
                  56:'312x1608y1468z',
                  57:'312x1777y1258z',
                  58:'31x1841y1203z',
                  59:'31x217y2189z',
                  60:'32x57y2199z',
                  61:'355x1325y1719z',
                  62:'380x1989y858z',
                  63:'38x193y2191z',
                  64:'38x78y2198z',
                  65:'392x1575y1484z',
                  66:'400x1898y1036z',
                  67:'402x1746y1276z',
                  68:'418x1288y1733z',
                  69:'43x101y2197z',
                  70:'43x170y2192z',
                  71:'45x123y2196z',
                  72:'45x147y2194z',
                  73:'470x1538y1500z',
                  74:'479x1248y1746z',
                  75:'481x1958y878z',
                  76:'489x1710y1294z',
                  77:'496x1865y1056z',
                  78:'536x1206y1759z',
                  79:'545x1497y1516z',
                  80:'574x1670y1311z',
                  81:'580x1922y898z',
                  82:'58x1680y1418z',
                  83:'590x1826y1075z',
                  84:'591x1160y1772z',
                  85:'616x1452y1532z',
                  86:'642x1112y1785z',
                  87:'64x2049y797z',
                  88:'655x1625y1329z',
                  89:'677x1880y918z',
                  90:'681x1782y1094z',
                  91:'685x1404y1548z',
                  92:'689x1062y1798z',
                  93:'69x54y2198z',
                  94:'733x1010y1811z',
                  95:'734x1576y1347z',
                  96:'750x1353y1563z',
                  97:'75x1438y1663z',
                  98:'768x1734y1113z',
                  99:'771x1834y938z',
                  100:'774x956y1823z',
                  101:'809x1524y1364z',
                  102:'811x1299y1579z',
                  103:'811x900y1835z',
                  104:'83x72y2197z',
                  105:'844x844y1847z',
                  106:'853x1681y1132z',
                  107:'862x1782y958z',
                  108:'869x1241y1594z',
                  109:'873x786y1859z',
                  110:'881x1468y1381z',
                  111:'898x727y1871z',
                  112:'920x668y1882z',
                  113:'923x1181y1609z',
                  114:'934x1625y1151z',
                  115:'948x1408y1398z',
                  116:'949x1726y978z',
                  117:'95x91y2196z',
                  118:'973x1119y1624z',
                  119:'99x1968y978z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2200one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2200one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2200ONE4XI - STARTED TIME: ", time2start)
        # 04:55:42 08/23/10 Pacific Daylight Time 
        
        print("\n (STEP 1A2/33) OF FIRE2200ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2200ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2200ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2200ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE22004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one22004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2200ONE4XI - SUCCEEDED TO PUT SHOT2ONE22004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE22004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2200ONE4XI *** FAILED TO PUT SHOT2ONE22004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2200ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one22004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one22004xi</nack2put4xi>" 
                
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
     
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2200ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one22004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE2200ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2200ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2200one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
